Attribute VB_Name = "ModInternet"
Option Explicit
Public Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, ByVal sProxyBypass As String, ByVal lFlags As Long) As Long
Public Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" (ByVal hInternetSession As Long, ByVal sUrl As String, ByVal sHeaders As String, ByVal lHeadersLength As Long, ByVal lFlags As Long, ByVal lContext As Long) As Long
Public Declare Function InternetReadFile Lib "wininet.dll" (ByVal hFile As Long, ByVal sBuffer As String, ByVal lNumberOfBytesToRead As Long, lNumberOfBytesRead As Long) As Integer
Public Declare Function InternetCloseHandle Lib "wininet.dll" (ByVal hInet As Long) As Integer

Public Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Public Const INTERNET_FLAG_RELOAD = &H80000000

Public Function getURL(url As String) As String

    Dim hInternetSession       As Long
    Dim hUrlFile               As Long
    Dim sReadBuffer            As String * 4096     ' Grab 4k at a time
    Dim sBuffer                As String
    Dim lNumberOfBytesRead     As Long
    Dim bDoLoop                As Boolean
    
    hInternetSession = InternetOpen("core update", INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)
    hUrlFile = InternetOpenUrl(hInternetSession, url, vbNullString, 0, INTERNET_FLAG_RELOAD, 0)
    bDoLoop = True
    While bDoLoop
        sReadBuffer = ""
        bDoLoop = InternetReadFile(hUrlFile, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
        sBuffer = sBuffer & Left$(sReadBuffer, lNumberOfBytesRead)
    If Not CBool(lNumberOfBytesRead) Then bDoLoop = False
    Wend
    InternetCloseHandle (hUrlFile)
    InternetCloseHandle (hInternetSession)
'    Debug.Print sBuffer
    getURL = sBuffer

End Function

